public class StrEnc
{
	boolean debug = false;

	//The Wheels
	Wheel w0 = new Wheel("bcagdefhilkjomnrqpu vstwzyx.94/3,20!+\\?@81\"5'+$(6)-7");
	Wheel w1 = new Wheel("chtzwefdbyiqljuvskgaxorpnm\"6-(1$873,04 /.!25'\\+?)9@+");
	Wheel w2 = new Wheel("x6pr8g7+2!n0$+dw\\z?@4lhya5mo.v)9-,1 (3sqiu'etb\"jcfk/");

	int[] letter_order = new int[51];
	int l;
	int letter_limit = 51;
	int letters_total= 52;

	//Constructor
	public void StrEnc(int state)
	{
		if(state==1) debug=true;
	}
	
	//Encrytes the Message given as parameter
	StringBuffer Encryptor(String input_text)
	{
		input_text = input_text.toLowerCase();
		l = input_text.length();

		char c;
		StringBuffer output_text = new StringBuffer(letter_limit);
		for(int i=0;i<l;i++)
		{
			c = input_text.charAt(i);
			int letters_number = charToNumber(c);
			int pos = letters_number;

			if(letters_number==-1) c=' ';		//If the inputed char is not a alphabet
			else
			{
													//System.out.print(c+") pos1="+pos);
				pos = pos + w2.enc_position;		//System.out.print("|pos2="+pos);
				if(pos > letter_limit) pos = pos - letters_total;
				pos = w2.letter_order[pos];			//System.out.print("|pos3="+pos);

													//System.out.print("|pos4="+pos);
				pos = pos + w1.enc_position;	//Turns the wheel to its 'enc_position'
													//System.out.print("|pos5="+pos);
				if(pos > letter_limit) pos = pos - letters_total;    //Makes the corrections. The wheel is a circle. So if it is after 25 it must be corrected
				pos = w1.letter_order[pos];		//Finds the number at 'pos' and give it for the next wheel
													//System.out.print("|pos6="+pos);
													//if(debug) System.out.print(i+") "+c+"|ln= "+letters_number+"|pos(w1) = "+pos);
				pos = pos + w0.enc_position;
													//System.out.print("|pos7="+pos);
				if(pos > letter_limit) pos = pos - letters_total;

				c = numberToChar(w0.letter_order[pos]);
													//System.out.println("|pos8="+pos+" ==> "+c);
													//if(debug) System.out.println("|pos(w0) = "+pos+"|Position = "+w0.enc_position+"|Ans = "+c+"("+w0.letter_order[pos]+")");
			}
			w0.enc_position++; 					//Turns the wheel one time
			if(w0.enc_position>letter_limit)				//One full turn of wheel w0 is completed 
			{
				w0.enc_position=0;
				w1.enc_position++;
			}
			if(w1.enc_position>letter_limit)				//One full turn of wheel w1 is completed 
			{
				w1.enc_position=0;
				w2.enc_position++;
			}
			output_text.append(c);
		}		
		return output_text;
	}


	//Decrypts the Message
	StringBuffer Decryptor(String input_text)
	{
		input_text = input_text.toLowerCase();
		l = input_text.length();

		char c=' ';
		StringBuffer output_text = new StringBuffer(letter_limit);

		for(int j=0;j<l;j++)
		{
			c = input_text.charAt(j);

			char decrypt = ' ';		
			int to = -1;
			int from = charToNumber(c); 			//Gets the 'from' of the encrypted charecter
													//	if(debug) System.out.print(j+") "+c+"|from = "+from+"|to 1 = "+to);
			for(int i=0;i<letter_limit;i++) //Wheel 1(w0)
				if(w0.letter_order[i] == from) {to = i;break;} //Searchs the char 'c'(as a nuber) in the 'letter_order'. If found, the position is sorted in 'to'.
			to = to - w0.dec_position;				//Adjusts the wheel position
			if(to<0) to = to + letters_total;		//If the given 'to' is before a, find its original char from end
														
			for(int i=0;i<letter_limit;i++) //Wheel 2(w1)
				if(w1.letter_order[i] == to) {to = i;break;}
			to = to - w1.dec_position;
			if(to<0) to = to + letters_total;

			for(int i=0;i<letter_limit;i++) //Wheel 3(w2)
				if(w2.letter_order[i] == to) {to = i;break;}
			to = to - w2.dec_position;
			if(to<0) to = to + letters_total;
													//	if(debug) System.out.print("|to 2 = "+to);
			w0.dec_position++;						//Turns the wheel one step

			decrypt=numberToChar(to); 				//Find the letter in 'to'
			if(c==' ') decrypt = ' ';				//If the inputed text is space, return space

			if(w0.dec_position > letter_limit)				//If dec_position exeeds the limit, start at top
				{
					 w0.dec_position=0;
					 w1.dec_position++;				//Turns the w1 wheel one time
				}
			if(w1.dec_position > letter_limit)				//w1 turns complete
				{
					 w1.dec_position=0;
					 w2.dec_position++;
				}
													//	if(debug) System.out.println("|decrypt = "+decrypt+"|w0 = "+w0.dec_position+"|w1 = "+w1.dec_position);
			output_text.append(decrypt);
		}		
		return output_text;
	}
	
	
		//Gets the number of the letter ie. a=0,b=1,c=2 etc
	int charToNumber(char c)
	{
		int v = -1;		
		if(c=='a') v = 0;		else if(c=='b') v = 1;
		else if(c=='c') v = 2;	else if(c=='d') v = 3;
		else if(c=='e') v = 4;	else if(c=='f') v = 5;
		else if(c=='g') v = 6;	else if(c=='h') v = 7;
		else if(c=='i') v = 8;	else if(c=='j') v = 9;
		else if(c=='k') v = 10;	else if(c=='l') v = 11;
		else if(c=='m') v = 12;	else if(c=='n') v = 13;
		else if(c=='o') v = 14;	else if(c=='p') v = 15;
		else if(c=='q') v = 16;	else if(c=='r') v = 17;
		else if(c=='s') v = 18;	else if(c=='t') v = 19;
		else if(c=='u') v = 20;	else if(c=='v') v = 21;
		else if(c=='w') v = 22;	else if(c=='x') v = 23;
		else if(c=='y') v = 24;	else if(c=='z') v = 25;
		else if(c=='0') v = 26;	else if(c=='1') v = 27;
		else if(c=='2') v = 28;	else if(c=='3') v = 29;
		else if(c=='4') v = 30;	else if(c=='5') v = 31;
		else if(c=='6') v = 32;	else if(c=='7') v = 33;
		else if(c=='8') v = 34;	else if(c=='9') v = 34;
		else if(c=='!') v = 35;	else if(c=='"') v = 36;
		else if(c=='$') v = 37;	else if(c=='\'') v = 38;
		else if(c=='(') v = 39;	else if(c==')') v = 40;
		else if(c=='+') v = 42;	else if(c=='\\') v = 41;
		else if(c==',') v = 43;	else if(c=='-') v = 44;
		else if(c=='.') v = 45;	else if(c=='/') v = 46;
		else if(c=='?') v = 47;	else if(c=='@') v = 48;
		else if(c==' ') v = 49;
		return v;
	}
	
	//Gets the letter of the number ie. 0=a,1=b,2=c etc
	public char numberToChar(int b)
	 {
	 	char a='*';
	 	if(b==0) a = 'a';		else if(b==1) a = 'b';
		else if(b==2) a = 'c';	else if(b==3) a = 'd';
		else if(b==4) a = 'e';	else if(b==5) a = 'f';
		else if(b==6) a = 'g';	else if(b==7) a = 'h';
		else if(b==8) a = 'i';	else if(b==9) a = 'j';
		else if(b==10) a = 'k';	else if(b==11) a = 'l';
		else if(b==12) a = 'm';	else if(b==13) a = 'n';
		else if(b==14) a = 'o';	else if(b==15) a = 'p';
		else if(b==16) a = 'q';	else if(b==17) a = 'r';
		else if(b==18) a = 's';	else if(b==19) a = 't';
		else if(b==20) a = 'u';	else if(b==21) a = 'v';
		else if(b==22) a = 'w';	else if(b==23) a = 'x';
		else if(b==24) a = 'y';	else if(b==25) a = 'z';
		else if(b==26) a = '0';	else if(b==27) a = '1';
		else if(b==28) a = '2';	else if(b==29) a = '3';
		else if(b==30) a = '4';	else if(b==31) a = '5';
		else if(b==32) a = '6';	else if(b==33) a = '7';
		else if(b==34) a = '8';	else if(b==34) a = '9';
		else if(b==35) a = '!';	else if(b==36) a = '"';
		else if(b==37) a = '$';	else if(b==38) a = '\'';
		else if(b==39) a = '(';	else if(b==40) a = ')';
		else if(b==42) a = '+';	else if(b==41) a = '\\';
		else if(b==43) a = ',';	else if(b==44) a = '-';
		else if(b==45) a = '.';	else if(b==46) a = '/';
		else if(b==47) a = '?';	else if(b==48) a = '@';
		else if(b==49) a = ' ';
		return a;
	}
}